#pragma once

#include "NWindowAdapter.h"
#include "SimpleTextShape.h"
#include "ScriptletContainerFactory.h"

class EditCtrl;
class NPCOMMONUI_API SimpleEdit : public CSimpleTextShape
{
public:
	DECLARE_COMPONENT_CREATOR(SimpleEdit);
	SimpleEdit(void);
	~SimpleEdit(void);

	//override
	LPCTSTR GetClassName() { return SCRIPTLET_SIMPLEEDIT_NODE; }
	void OnAddNotify();
	void OnRemoveNotify();
	void SetText(LPCTSTR text);
	BOOL GetOrginPreferredSize(LPSIZE lpSize)
	{
		return CComponent::GetOrginPreferredSize(lpSize);
	}
	//operation
	void SetMultiline(BOOL b) { m_bMultiline = b; }
	BOOL IsMultiline() { return m_bMultiline; }
	void SetSel(int start, int end);
	void SetLimitText(int maxText);
	void SetFocus();
	LPCTSTR GetText();
	BOOL IsChanged();
	void SetReadOnly(BOOL bReadOnly) { m_bReadOnly = bReadOnly; }

	virtual void OnEnChange() {}

private:	
	EditCtrl* m_Edit;
	BOOL m_bMultiline;
	BOOL m_bReadOnly;

	HFONT CreateTextFont(HDC hDC);
};



#include "SimpleTextScriptletPlugin.h"
#include "ScriptletContainerFactory.h"

class SimpleEditScriptPlugin : public CSimpleTextScriptletPlugin
{
public:
	DECLARE_REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SimpleEditScriptPlugin);
	SimpleEditScriptPlugin(void);
	virtual ~SimpleEditScriptPlugin(void);

	//override
	BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode);
	CComponent* _CreateComponent(TiXmlElement* pNode);
};

#include "ControlPropertyAccessor.h"

class SimpleEditPropertyAccessor : public ControlPropertyAccessor
{
public:
	DECLARE_PROPERTY_ACCESSOR(SimpleEditPropertyAccessor);
	SimpleEditPropertyAccessor(void) {}
	virtual ~SimpleEditPropertyAccessor(void) {}

	//override
	BOOL SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value);
	BOOL GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value);
};